using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace KokhCurve
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TrackBar trackBar1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.label1 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			this.SuspendLayout();
			// 
			// trackBar1
			// 
			this.trackBar1.Location = new System.Drawing.Point(312, 256);
			this.trackBar1.Maximum = 7;
			this.trackBar1.Minimum = 1;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Size = new System.Drawing.Size(88, 45);
			this.trackBar1.TabIndex = 0;
			this.trackBar1.Value = 1;
			this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label1.Location = new System.Drawing.Point(160, 260);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(152, 24);
			this.label1.TabIndex = 1;
			this.label1.Text = " :";
			// 
			// textBox1
			// 
			this.textBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.textBox1.Location = new System.Drawing.Point(410, 260);
			this.textBox1.Name = "textBox1";
			this.textBox1.ReadOnly = true;
			this.textBox1.Size = new System.Drawing.Size(24, 22);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "";
			this.textBox1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(536, 256);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 24);
			this.button1.TabIndex = 3;
			this.button1.Text = "";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(634, 308);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button1,
																		  this.textBox1,
																		  this.label1,
																		  this.trackBar1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.Text = "  ";
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		public void Kokh(float startx, float starty, float endx, float endy, int level)
		{
			float x1 = startx, x2 = endx, x3, y1 = starty, y2 = endy, y3, dist, cosa, sina, h;
			System.Drawing.Graphics gr = this.CreateGraphics();
			this.Show();
			if(level==1) 
			{
				gr.DrawLine(new Pen(Color.Black), x1, y1, x2, y2);
			}
			else
			{
				dist = (float) Math.Sqrt( (endx-startx) * (endx-startx) + (endy-starty) * (endy-starty) );
				h = dist / (2 * (float) Math.Sqrt(3));
				sina = (endy - starty) / dist;
				cosa = (endx - startx) / dist;
				x1 = startx + (endx - startx) / 3;
				x2 = (endx + startx) / 2 + h * sina;
				x3 = startx + 2 * (endx - startx) / 3;
				y1 = starty + (endy - starty) / 3;
				y2 = (endy + starty) / 2 - h * cosa;
				y3 = starty + 2 * (endy - starty) / 3;
				Kokh(startx, starty, x1, y1, level-1);
				Kokh(x1, y1, x2, y2, level-1);
				Kokh(x2, y2, x3, y3, level-1);
				Kokh(x3, y3, endx, endy, level-1);
			}
		}
		
		private void DrawKokh()
		{
			System.Drawing.Graphics gr = this.CreateGraphics();
			gr.Clip = new Region(new Rectangle(10, 10, 615, 210));
			gr.Clear(Color.White);
			textBox1.Text = trackBar1.Value.ToString();
			textBox1.Refresh();
			Kokh(10, 200, 625, 200, trackBar1.Value);
		}

		private void trackBar1_Scroll(object sender, System.EventArgs e)
		{
			DrawKokh();
		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			DrawKokh();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}
	}
}
